"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var CSSStyleDeclaration_1 = __importDefault(require("./CSSStyleDeclaration"));
/**
 * CSSStyleDeclaration interface.
 */
var CSSStyleDeclarationFactory = /** @class */ (function () {
    function CSSStyleDeclarationFactory() {
    }
    /**
     * Create a CSSStyleDeclaration.
     *
     * @param [cssText] CSS text.
     * @param [parentRule] Parent rule.
     */
    CSSStyleDeclarationFactory.createCSSStyleDeclaration = function (cssText, parentRule) {
        if (cssText === void 0) { cssText = null; }
        if (parentRule === void 0) { parentRule = null; }
        var cssStyleDeclaration = new CSSStyleDeclaration_1.default();
        // @ts-ignore
        cssStyleDeclaration.parentRule = parentRule;
        if (cssText) {
            for (var _i = 0, _a = cssText.replace(/[\n\r]/gm, '').split(';'); _i < _a.length; _i++) {
                var part = _a[_i];
                var _b = part.split(':'), key = _b[0], value = _b[1];
                if (key && value) {
                    cssStyleDeclaration.setProperty(key.trim(), value.trim());
                }
            }
        }
        return cssStyleDeclaration;
    };
    return CSSStyleDeclarationFactory;
}());
exports.default = CSSStyleDeclarationFactory;
//# sourceMappingURL=CSSStyleDeclarationFactory.js.map