import Element from '../element/Element';
import IHTMLElement from './IHTMLElement';
import CSSStyleDeclaration from '../../../css/CSSStyleDeclaration';
/**
 * HTMLElement.
 */
export default class HTMLElement extends Element implements IHTMLElement {
    tabIndex: number;
    offsetHeight: number;
    offsetWidth: number;
    offsetLeft: number;
    offsetTop: number;
    clientHeight: number;
    clientWidth: number;
    private _style;
    /**
     * Returns inner text.
     *
     * @return Text.
     */
    get innerText(): string;
    /**
     * Sets inner text.
     *
     * @param text Text.
     */
    set innerText(text: string);
    /**
     * Returns style.
     *
     * @return Style.
     */
    get style(): CSSStyleDeclaration;
    /**
     * Triggers a click event.
     */
    click(): void;
    /**
     * Triggers a blur event.
     */
    blur(): void;
    /**
     * Triggers a focus event.
     */
    focus(): void;
    /**
     * Clones a node.
     *
     * @override
     * @param [deep=false] "true" to clone deep.
     * @return Cloned node.
     */
    cloneNode(deep?: boolean): HTMLElement;
}
