import DocumentFragment from '../document-fragment/DocumentFragment';
import Element from '../element/Element';
import CSSStyleSheet from '../../../css/CSSStyleSheet';
/**
 * ShadowRoot.
 */
export default class ShadowRoot extends DocumentFragment {
    readonly mode = "open";
    readonly host: Element;
    adoptedStyleSheets: CSSStyleSheet[];
    /**
     * Returns inner HTML.
     *
     * @return HTML.
     */
    get innerHTML(): string;
    /**
     * Sets inner HTML.
     *
     * @param html HTML.
     */
    set innerHTML(html: string);
    /**
     * Converts to string.
     *
     * @return String.
     */
    toString(): string;
    /**
     * Clones a node.
     *
     * @override
     * @param [deep=false] "true" to clone deep.
     * @return Cloned node.
     */
    cloneNode(deep?: boolean): ShadowRoot;
}
