"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var HTMLElement_1 = __importDefault(require("../../basic/html-element/HTMLElement"));
/**
 * HTMLFormElement.
 */
var HTMLFormElement = /** @class */ (function (_super) {
    __extends(HTMLFormElement, _super);
    function HTMLFormElement() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.name = '';
        _this.method = 'get';
        _this.target = '';
        _this.action = '';
        _this.encoding = '';
        _this.enctype = '';
        _this.acceptCharset = '';
        _this.autocomplete = '';
        _this.noValidate = '';
        return _this;
    }
    Object.defineProperty(HTMLFormElement.prototype, "elements", {
        /**
         * Returns input elements.
         *
         * @returns Elements.
         */
        get: function () {
            return this.querySelectorAll('input,textarea');
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HTMLFormElement.prototype, "length", {
        /**
         * Returns number of input elements.
         *
         * @return Length.
         */
        get: function () {
            return this.elements.length;
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Submits form.
     */
    HTMLFormElement.prototype.submit = function () { };
    /**
     * Resets form.
     */
    HTMLFormElement.prototype.reset = function () { };
    /**
     * Reports validity.
     */
    HTMLFormElement.prototype.reportValidity = function () { };
    /**
     * Checks validity.
     *
     * @return "true" if validation does'nt fail.
     */
    HTMLFormElement.prototype.checkValidity = function () {
        return true;
    };
    /**
     * Removes an Attr node.
     *
     * @override
     * @param attribute Attribute.
     */
    HTMLFormElement.prototype.removeAttributeNode = function (attribute) {
        _super.prototype.removeAttributeNode.call(this, attribute);
        switch (attribute.name) {
            case 'method':
                this[attribute.name] = 'get';
                break;
            case 'name':
            case 'target':
            case 'action':
            case 'encoding':
            case 'enctype':
            case 'autocomplete':
                this[attribute.name] = '';
                break;
            case 'acceptcharset':
                this.acceptCharset = '';
                break;
            case 'novalidate':
                this.noValidate = '';
                break;
        }
    };
    /**
     * The setAttributeNode() method adds a new Attr node to the specified element.
     *
     * @override
     * @param attribute Attribute.
     * @returns Replaced attribute.
     */
    HTMLFormElement.prototype.setAttributeNode = function (attribute) {
        var replacedAttribute = _super.prototype.setAttributeNode.call(this, attribute);
        switch (attribute.name) {
            case 'name':
            case 'method':
            case 'target':
            case 'action':
            case 'encoding':
            case 'enctype':
            case 'autocomplete':
                this[attribute.name] = attribute.value;
                break;
            case 'acceptcharset':
                this.acceptCharset = attribute.value;
                break;
            case 'novalidate':
                this.noValidate = attribute.value;
                break;
        }
        return replacedAttribute;
    };
    /**
     * Clones a node.
     *
     * @override
     * @param [deep=false] "true" to clone deep.
     * @return Cloned node.
     */
    HTMLFormElement.prototype.cloneNode = function (deep) {
        if (deep === void 0) { deep = false; }
        var clone = _super.prototype.cloneNode.call(this, deep);
        clone.name = this.name;
        clone.method = this.method;
        clone.target = this.target;
        clone.action = this.action;
        clone.encoding = this.encoding;
        clone.enctype = this.enctype;
        clone.acceptCharset = this.acceptCharset;
        clone.autocomplete = this.autocomplete;
        clone.noValidate = this.noValidate;
        return clone;
    };
    return HTMLFormElement;
}(HTMLElement_1.default));
exports.default = HTMLFormElement;
//# sourceMappingURL=HTMLFormElement.js.map